summaryrefslogtreecommitdiff
path: root/tests/chown/preserve-root
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-12-14 11:09:44 +0100
committerJim Meyering <jim@meyering.net>2006-12-14 11:14:25 +0100
commit24852bf5b5e7fd954f2e4d1d08d58575453b48b0 (patch)
tree84eb0a48a2ec2d2b9637fa4d1890f941e4d5e647 /tests/chown/preserve-root
parent56007809c35dc4c3d139662578741281e11d0e3b (diff)
downloadcoreutils-24852bf5b5e7fd954f2e4d1d08d58575453b48b0.tar.xz
* NEWS: --preserve-root now works with chgrp, chmod, and chown.
* src/chmod.c (process_file): Do honor the --preserve-root option. * src/chown-core.c (change_file_owner): Likewise, but here, also handle the case in which a traversal would go "through" a symlink to root. Reported by Matthew M. Boedicker * tests/chown/preserve-root: Test for the above. * tests/chown/Makefile.am (TESTS): Add preserve-root.
Diffstat (limited to 'tests/chown/preserve-root')
-rwxr-xr-xtests/chown/preserve-root70
1 files changed, 70 insertions, 0 deletions
diff --git a/tests/chown/preserve-root b/tests/chown/preserve-root
new file mode 100755
index 000000000..152f59c30
--- /dev/null
+++ b/tests/chown/preserve-root
@@ -0,0 +1,70 @@
+#!/bin/sh
+# Verify that --preserve-root works.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chown --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir d && ln -s / d/slink-to-root
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# Even if --preserve-root were to malfunction, allowing the chown or
+# chgrp to traverse through "/", since we're running as non-root,
+# they would be very unlikely to cause any changes.
+chown -R --preserve-root 0 / > out 2>&1 && fail=1
+chgrp -R --preserve-root 0 / >> out 2>&1 && fail=1
+
+# Here, if --preserve-root were to malfunction, chmod could make changes,
+# but only to files owned and unreadable by the user running this test,
+# and then, only to make them readable by owner.
+chmod -R --preserve-root u+r / >> out 2>&1 && fail=1
+
+cat <<\EOF > exp || fail=1
+chown: it is dangerous to operate recursively on `/'
+chown: use --no-preserve-root to override this failsafe
+chgrp: it is dangerous to operate recursively on `/'
+chgrp: use --no-preserve-root to override this failsafe
+chmod: it is dangerous to operate recursively on `/'
+chmod: use --no-preserve-root to override this failsafe
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail